#ifndef SYNTHINO_H
#define SYNTHINO_H

//#define DEBUG_ENABLE
//#define TEST
#define BUTTON1_PIN 6
#define BUTTON2_PIN 7
#define BUTTON3_PIN 8
#define BUTTON4_PIN 9
#define LED 3


#define BUTTON1 0
#define BUTTON2 1
#define BUTTON3 2
#define BUTTON4 3


#define SILENCE 2048
#define MIDI_LOW 21
#define MIDI_HIGH 108
#define N_MIDI_CHANNELS 4
#define NOTE_OFF 0
#define NOTE_PENDING_OFF 1
#define MAX_NOTES 4
#define MAX_NOTE_VOL 32
#define N_BUTTONS 4
#define DEFAULT_VELOCITY 40
#define MAX_VELOCITY 50
#define BASE_TUNING_ADJUSTMENT 1.0
#define EEPROM_MAGIC_NUMBER 0xbad0
#define POLYPHONIC_RATE 15000
#define MONOSYNTH_RATE 30000

#define ATTACK 0
#define DECAY 1
#define SUSTAIN 2
#define RELEASE 3
#define POT_TOLERANCE 10

typedef struct {
  volatile byte midiVal;
  float frequency;
  prog_int16_t *waveformBuf;
  int volLevelDuration;
  volatile int volLevelRemaining;
  byte envelopePhase;
  byte volIndex;
  byte targetVolIndex;
  int volIndexInc;
  byte midiChannel;
  long startTime;
  byte volume;
  byte volumeNext;
  volatile unsigned int phase;
  volatile unsigned int phaseInc;
  volatile byte phaseFraction;
  volatile byte phaseFractionInc;
} note_t;

typedef struct {
  byte waveform;
  int attackVolLevelDuration;
  int decayVolLevelDuration;
  float sustainVolLevel;
  int releaseVolLevelDuration;
} channel_t;

typedef struct {
  int pitchReading;
  byte waveformReading;
  int attackReading;
  int decayReading;
  float sustainReading;
  int releaseReading;
  byte note; // MIDI note assigned to button
  byte lastNote; // last MIDI note assigned to button before release
} button_t;

#endif

