#ifndef waveforms_h
#define waveforms_h
//#define SMALLMEM

#include <inttypes.h>
#if defined(ARDUINO) && ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
  #include <pins_arduino.h>
#endif

#ifndef SMALLMEM
#define N_WAVEFORMS 13
#else
#define N_WAVEFORMS 5
#endif

#define N_LFO_WAVEFORMS 5
#define N_WAVEFORM_SAMPLES 600


extern prog_int16_t *waveformBuffers[];
extern prog_int16_t *lfoWaveformBuffers[];

extern prog_int16_t sin_0001[];
extern prog_int16_t tri_0001[];
extern prog_int16_t saw_0001[];
extern prog_int16_t squ[];
extern prog_int16_t piano_0001[];
extern prog_int16_t epiano_0001[];
extern prog_int16_t eorgan_0001[];
extern prog_int16_t cello_0001[];
extern prog_int16_t altosax_0001[];
extern prog_int16_t oboe_0001[];
extern prog_int16_t ebass_0001[];
extern prog_int16_t c604_0027[];
extern prog_int16_t akwf_1603[];

#endif
